/*
 * ocr.c forms a mostly-self-contained bit
 * so we put its declarations in this separate file
 */

#ifndef OCR_H
#define OCR_H


// #define DEBUG_RECTANGLES
// #define DEBUG_OCR


#define _GNU_SOURCE

#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <assert.h>
#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>
#include <inttypes.h>

#include <sys/types.h>
#include <sys/wait.h>


typedef struct {
  int w,h;
  char d[];
} CanonImage;

typedef uint32_t Pixcol;
#define PSPIXCOL(priscan) priscan##32

typedef struct {
  const char *s; /* valid until next call to ocr() */
  int l,r; /* column numbers */
  unsigned ctxmap; /* match context index */
} OcrResultGlyph;


typedef const struct OcrCellTypeInfo *OcrCellType;
extern const struct OcrCellTypeInfo ocr_celltype_text;
extern const struct OcrCellTypeInfo ocr_celltype_number;


typedef struct OcrReader OcrReader;
OcrReader *ocr_init(int h);

OcrResultGlyph *ocr(OcrReader *rd, OcrCellType, int w, Pixcol cols[]);
  /* return value is array terminated by {0,-1,-1}
   * array is valid until next call to ocr()
   */


/*----- debugging arrangements, rather contingent -----*/

void debug_flush(void);

#define eassert assert
#define debug stderr

const char *get_vardir(void);

#endif /*OCR_H*/
